indexing

	description: "Class that gets Posix stat structure through stat call."

  author: "Berend de Boer"
	date: "$Date: Fri, 13 Oct 2000 13:36:48 +0200 $"
	revision: "$Revision: 1.3 $"

class 

   POSIX_STATUS_PATH
   

inherit
   
   POSIX_STATUS

   PAPI_STAT


creation {POSIX_FILE_SYSTEM}
   
   make
   
   
feature {POSIX_FILE_SYSTEM} -- creation

   make (a_path: STRING) is
      require
         valid_path: a_path /= Void
      do
         make_stat
         create path.make (a_path)
         cpath := sh.string_to_pointer (path)
         refresh
      end

  
feature 
   
   refresh is
         -- Refresh the cached status information
      local
         r: INTEGER
      do
         r := posix_stat (cpath, stat.ptr)
         if r = -1 then
            raise_posix_error
         end
         if my_permissions /= Void then
            my_permissions.update_from_status
         end
      end


feature -- stat members   
   
   permissions: POSIX_PERMISSIONS is
         -- file permissions
      do
         if my_permissions = Void then
            create {POSIX_PERMISSIONS_PATH} my_permissions.make (Current)
         end
         Result := my_permissions
      end


feature {NONE} -- state

   path: STDC_PATH
         -- the path we cached the status for

   my_permissions: POSIX_PERMISSIONS


feature {POSIX_PERMISSIONS_PATH} -- state

   cpath: POINTER
         -- pointer to `path'
   

invariant  
   
   valid_path: path /= Void
   
end -- class POSIX_STATUS_PATH
