/*

Eiffel's INTEGER type doesn't allow the very usefull or, and and xor stuff.
And yo can't make an INTEGER into a BIT, the class that has these
features, at least not portable. More than enough work for ELKS2000.

*/

#define _POSIX_SOURCE 1

#ifndef _C_SUPPORT_H_
#define _C_SUPPORT_H_

#include "eiffel.h"
#ifdef _WINDOWS_
#include <io.h>
#else
#include <unistd.h>
#endif


/* bit operations */

EIF_INTEGER posix_and (EIF_INTEGER op1, EIF_INTEGER op2);
EIF_INTEGER posix_not (EIF_INTEGER op);
EIF_INTEGER posix_or (EIF_INTEGER op1, EIF_INTEGER op2);


/* read/write arbitrary bytes */

EIF_INTEGER posix_peek_byte(EIF_POINTER ptr, EIF_INTEGER index);
void posix_poke_byte(EIF_POINTER ptr, EIF_INTEGER index, EIF_INTEGER value);
EIF_INTEGER posix_peek_integer(EIF_POINTER ptr, EIF_INTEGER index);


/* which platform?? */

EIF_BOOLEAN is_windows();


#endif /* _C_SUPPORT_H_ */
